<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use App\Http\Services\StokkapalService;

class AdjustmentLogModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "pelni_scm_others_trx_v";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "adjlog";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "SOURCE", "TRANSACTION_ID", "TRANSACTION_NUM", "ITEM_ID", "QTY", "UOM_CODE", "PO", "PO_ID", "ORGANIZATION_ID", "SUBINVENTORY_CODE", "LOT_NUMBER", "CREATION_DATE", "LAST_UPDATE_DATE", "TRANSACTION_DATE"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "adjlog.id",
    ];



    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        echo "start sync data adj Log from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Adjustment Log", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Adjustment Log", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT
                      ADJLOG.*
                    FROM PELNI_SCM_OTHERS_TRX_V ADJLOG
                    WHERE
                    ADJLOG.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS')
                    ORDER BY ADJLOG.LAST_UPDATE_DATE ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->SOURCE = $oracle->SOURCE;
        $this->TRANSACTION_ID = $oracle->TRANSACTION_ID;
        $this->TRANSACTION_NUM = $oracle->TRANSACTION_NUM;
        $this->ITEM_ID = $oracle->ITEM_ID;
        $this->QTY = $oracle->QTY;
        $this->UOM_CODE = $oracle->UOM_CODE;
        //        $this->PO = $oracle->PO;
        //        $this->PO_ID = $oracle->PO_ID;
        $this->ORGANIZATION_ID = $oracle->ORGANIZATION_ID;
        $this->SUBINVENTORY_CODE = $oracle->SUBINVENTORY_CODE;
        $this->LOT_NUMBER = $oracle->LOT_NUMBER;
        $this->CREATION_DATE = $oracle->CREATION_DATE;
        $this->LAST_UPDATE_DATE = $oracle->LAST_UPDATE_DATE;
        $this->TRANSACTION_DATE = $oracle->TRANSACTION_DATE;
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        $modelExist = new self();
        $modelExist = $modelExist->getQuery()->where("adjlog.TRANSACTION_ID", "=", $oracle->TRANSACTION_ID)
            ->first();

        if ($modelExist) {
            try {
                $model = self::find($modelExist->id);
                $model->mapperOracle($oracle);
                $model->update();
                (new LogsyncoracleModel)->setLogSync("Adjustment Log: " . $oracle->TRANSACTION_ID . " - " . $oracle->ITEM_ID . " - " . $oracle->QTY, Carbon::now()->toDateTimeString(), "", "updated");
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Adjustment Log: " . $oracle->TRANSACTION_ID . " - " . $oracle->ITEM_ID . " - " . $oracle->QTY, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        } else {
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();

                (new LogsyncoracleModel)->setLogSync("Adjustment Log: " . $oracle->TRANSACTION_ID . " - " . $oracle->ITEM_ID . " - " . $oracle->QTY, Carbon::now()->toDateTimeString(), "", "inserted");
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Adjustment Log: " . $oracle->TRANSACTION_ID . " - " . $oracle->ITEM_ID . " - " . $oracle->QTY, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        }
    }

    public static function storeFromHO($data, $fromCMS = false)
    {
        $model = (new self())->getQuery()->where("adjlog.TRANSACTION_ID", "=", $data->TRANSACTION_ID)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->SOURCE = $data->SOURCE;
            $model->TRANSACTION_ID = $data->TRANSACTION_ID;
            $model->TRANSACTION_NUM = $data->TRANSACTION_NUM;
            $model->ITEM_ID = $data->ITEM_ID;
            $model->QTY = $data->QTY;
            $model->UOM_CODE = $data->UOM_CODE;
            $model->ORGANIZATION_ID = $data->ORGANIZATION_ID;
            $model->SUBINVENTORY_CODE = $data->SUBINVENTORY_CODE;
            $model->LOT_NUMBER = $data->LOT_NUMBER;
            $model->CREATION_DATE = $data->CREATION_DATE;
            $model->LAST_UPDATE_DATE = $data->LAST_UPDATE_DATE;
            $model->TRANSACTION_DATE = $data->TRANSACTION_DATE;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Adjustment Log: " . $data->TRANSACTION_ID . " - " . $data->LOT_NUMBER . " - " . $data->QTY, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->SOURCE = $data->SOURCE;
            $model->TRANSACTION_ID = $data->TRANSACTION_ID;
            $model->TRANSACTION_NUM = $data->TRANSACTION_NUM;
            $model->ITEM_ID = $data->ITEM_ID;
            $model->QTY = $data->QTY;
            $model->UOM_CODE = $data->UOM_CODE;
            $model->ORGANIZATION_ID = $data->ORGANIZATION_ID;
            $model->SUBINVENTORY_CODE = $data->SUBINVENTORY_CODE;
            $model->LOT_NUMBER = $data->LOT_NUMBER;
            $model->CREATION_DATE = $data->CREATION_DATE;
            $model->LAST_UPDATE_DATE = $data->LAST_UPDATE_DATE;
            $model->TRANSACTION_DATE = $data->TRANSACTION_DATE;
            $model->save();

            // STOCK HISTORY
            $stockService = new StokkapalService();
            $stockService->saveAdjusmentToStockHistory($model);

            (new LogsynckapalModel)->setLogSync("Adjustment Log: " . $data->TRANSACTION_ID . " - " . $data->LOT_NUMBER . " - " . $data->QTY, Carbon::now()->toDateTimeString(), "", "inserted");
        }
    }
    public static function updateTransactionSyncFlag($data, $fromCMS = false)
    {
        $transactionCode = substr($data->TRANSACTION_NUM, 0, 2);

        switch ($transactionCode) {
            case "RC": // PENERIMAAN BARANG IO
                (new ItempenerimaanbarangioModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "MS": // PENGGUNAAN MAKANAN
                (new ItempenggunaanmakananModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "MR": // PENERIMAAN MAKANAN
                (new ItempenerimaanmakananModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "MI": // PENGGUNAAN BARANG
                (new ItempenggunaanbarangModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "MO": // TRANSFER SUBINV
                (new ItempindahsubinvModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "IO": // TRANSFER IO
                (new ItemtransferioModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "PB": // PENERIMAAN BARANG
                (new ItempenerimaanbarangModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
            case "AB": // PENERIMAAN BARANG
                (new AdjustmentbbmModel)->updateTransactionSyncFlag($data->TRANSACTION_NUM, $data->ITEM_ID, $data->LOT_NUMBER);
                break;
        }
    }

    public static function getAdjustmentLog($fromCMS = false)
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_adjustmentlog";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 21)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Adjustment Log", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no, PHP_EOL;
                            \App\Http\Models\AdjustmentLogModel::storeFromHO($item, $fromCMS);
                            \App\Http\Models\AdjustmentLogModel::updateTransactionSyncFlag($item, $fromCMS);
                            $lastUpdate = $item->LAST_UPDATE_DATE;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Adjustment Log", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Adjustment Log", Carbon::now()->toDateTimeString(), "", "success");
    }
}
